<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        Default images and guidance on art by RJsaurus - https://twitter.com/deeposaurus
        BakkesWebApi by gboddin - Heavily modified and extended by SimpleAOB
            - Now available at: https://gitlab.com/bakkesplugins/sos/sos-plugin
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SOS - Rocket League OBS Browser Source Overlay</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
</head>
<body>
    <div class="page-container">
        <div class="waiting-for-websocket">
            <div class="technical-difficulties hidden"></div>
            <div class="text">
                Waiting for Websocket Server to connect...
            </div>
        </div>
    </div>
    <div class="bracket">
        <div class="bracket-lines"><img src="assets/backet_lines.png"></div>
        <div class="quarter-finals">
            <div class="group one"></div>
            <div class="group two"></div>
            <div class="group three"></div>
            <div class="group four"></div>
        </div>
        <div class="semi-finals">
            <div class="group one"></div>
            <div class="group two"></div>
        </div>
        <div class="finals">
            <div class="group one"></div>
        </div>
    </div>
    <script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
    <script>${require('../out/js/base.js')}</script>
    <script>
        //!!! Register the websocket listeners before attempting to connect
        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
            WsSubscribers.send("cb", "first_connect", {
                'name': 'Scorebug',
                'version': ${require('../version.txt')}
            });
            setInterval(function () {
                WsSubscribers.send("cb", "heartbeat", "heartbeat");
            }, 1000);
        });

        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
        });

        WsSubscribers.subscribe("ws", "error", function() {
            $(".waiting-for-websocket .text").text("[002] There has been an error with the Rocket League connection. Please stand by");
            $(".waiting-for-websocket").removeClass("hidden");
        });

        WsSubscribers.subscribe("ws", "close", function() {
            $(".waiting-for-websocket .text").text("[004] Connection to Rocket League has gone away. Please stand by");
            $(".waiting-for-websocket, .technical-difficulties").removeClass("hidden");
        });

        WsSubscribers.init(49322, false, [
            "game:update_tick",
            "cb:heartbeat"
        ]);
    </script>
    <script>
        $('.bracket .group').html(`
        <div class="team top">
            <div class="team-container">
                <svg  xmlns="http://www.w3.org/2000/svg" width="433px" height="80px">
                    <rect fill-rule="evenodd" class="team-color" fill="rgb(29, 29, 29)" width="433" height="80"/>
                </svg>
            </div>
            <div class="logo"><img src="../team_logos/Spacestation_Gaming.png"></div>
            <div class="seed">2</div>
            <div class="name">SPACESTATION</div>
            <div class="score">4</div>
        </div>
        <div class="team bottom">
            <div class="team-container">
                <svg  xmlns="http://www.w3.org/2000/svg" width="433px" height="80px">
                    <path fill-rule="evenodd" class="team-color" fill="rgb(29, 29, 29)" d="M433,79 L281,79 L281,79 L0,79 L0,19 L18,-0 L297,-0 L297,-0 L433,-0 L433,79 Z"/>
                </svg>
            </div>
            <div class="logo"><img src="../team_logos/C9.png"></div>
            <div class="seed">1</div>
            <div class="name">Cloud9</div>
            <div class="score">3</div>
        </div>
        `);

        WsSubscribers.subscribe("sos", "bracket_update", function (d) {
            setTeamContainer('.bracket .quarter-finals .group.one .team.top', d.qf.groups.one.top.name, d.qf.groups.one.top.seed, d.qf.groups.one.top.score, (d.qf.groups.one.top.score > d.qf.groups.one.bottom.score), (d.qf.groups.one.top.score > 0 || d.qf.groups.one.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.one .team.bottom', d.qf.groups.one.bottom.name, d.qf.groups.one.bottom.seed, d.qf.groups.one.bottom.score, (d.qf.groups.one.bottom.score > d.qf.groups.one.top.score), (d.qf.groups.one.bottom.score > 0 || d.qf.groups.one.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.two .team.top', d.qf.groups.two.top.name, d.qf.groups.two.top.seed, d.qf.groups.two.top.score, (d.qf.groups.two.top.score > d.qf.groups.two.bottom.score), (d.qf.groups.two.top.score > 0 || d.qf.groups.two.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.two .team.bottom', d.qf.groups.two.bottom.name, d.qf.groups.two.bottom.seed, d.qf.groups.two.bottom.score, (d.qf.groups.two.bottom.score > d.qf.groups.two.top.score), (d.qf.groups.two.bottom.score > 0 || d.qf.groups.two.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.three .team.top', d.qf.groups.three.top.name, d.qf.groups.three.top.seed, d.qf.groups.three.top.score, (d.qf.groups.three.top.score > d.qf.groups.three.bottom.score), (d.qf.groups.three.top.score > 0 || d.qf.groups.three.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.three .team.bottom', d.qf.groups.three.bottom.name, d.qf.groups.three.bottom.seed, d.qf.groups.three.bottom.score, (d.qf.groups.three.bottom.score > d.qf.groups.three.top.score), (d.qf.groups.three.bottom.score > 0 || d.qf.groups.three.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.four .team.top', d.qf.groups.four.top.name, d.qf.groups.four.top.seed, d.qf.groups.four.top.score, (d.qf.groups.four.top.score > d.qf.groups.four.bottom.score), (d.qf.groups.four.top.score > 0 || d.qf.groups.four.bottom.score > 0))
            setTeamContainer('.bracket .quarter-finals .group.four .team.bottom', d.qf.groups.four.bottom.name, d.qf.groups.four.bottom.seed, d.qf.groups.four.bottom.score, (d.qf.groups.four.bottom.score > d.qf.groups.four.top.score), (d.qf.groups.four.bottom.score > 0 || d.qf.groups.four.bottom.score > 0))

            setTeamContainer('.bracket .semi-finals .group.one .team.top', d.sf.groups.one.top.name, d.sf.groups.one.top.seed, d.sf.groups.one.top.score, (d.sf.groups.one.top.score > d.sf.groups.one.bottom.score), (d.sf.groups.one.top.score > 0 || d.sf.groups.one.bottom.score > 0))
            setTeamContainer('.bracket .semi-finals .group.one .team.bottom', d.sf.groups.one.bottom.name, d.sf.groups.one.bottom.seed, d.sf.groups.one.bottom.score, (d.sf.groups.one.bottom.score > d.sf.groups.one.top.score), (d.sf.groups.one.bottom.score > 0 || d.sf.groups.one.bottom.score > 0))
            setTeamContainer('.bracket .semi-finals .group.two .team.top', d.sf.groups.two.top.name, d.sf.groups.two.top.seed, d.sf.groups.two.top.score, (d.sf.groups.two.top.score > d.sf.groups.two.bottom.score), (d.sf.groups.two.top.score > 0 || d.sf.groups.two.bottom.score > 0))
            setTeamContainer('.bracket .semi-finals .group.two .team.bottom', d.sf.groups.two.bottom.name, d.sf.groups.two.bottom.seed, d.sf.groups.two.bottom.score, (d.sf.groups.two.bottom.score > d.sf.groups.two.top.score), (d.sf.groups.two.bottom.score > 0 || d.sf.groups.two.bottom.score > 0))

            setTeamContainer('.bracket .finals .group.one .team.top', d.ff.groups.one.top.name, d.ff.groups.one.top.seed, d.ff.groups.one.top.score, (d.ff.groups.one.top.score > d.ff.groups.one.bottom.score), (d.ff.groups.one.top.score > 0 || d.ff.groups.one.bottom.score > 0))
            setTeamContainer('.bracket .finals .group.one .team.bottom', d.ff.groups.one.bottom.name, d.ff.groups.one.bottom.seed, d.ff.groups.one.bottom.score, (d.ff.groups.one.bottom.score > d.ff.groups.one.top.score), (d.ff.groups.one.bottom.score > 0 || d.ff.groups.one.bottom.score > 0))

            SOSUtils.fitText(".bracket .name", 32);
        });

        let teamMap = ${require('../../team_logos/map.json')};
        function setTeamContainer(jquerySelector, name, seed, score, winner, played) {
            $(jquerySelector + " .name").text(name);
            $(jquerySelector + " .seed").text(seed);
            if (played) {
                $(jquerySelector + " .score").text(score);
            } else {
                $(jquerySelector + " .score").text('');
            }

            let nameLower = name.toLowerCase();
            if (teamMap.hasOwnProperty(nameLower)) {
                let team = teamMap[nameLower];
                $(jquerySelector + " .logo img").attr('src', `../team_logos/${team.logo}`);
                $(jquerySelector + " .team-color").attr('fill', team.background);
                if (team.black_text) {
                    $(jquerySelector).css('color', 'black');
                } else {
                    $(jquerySelector).css('color', 'white');
                }
                console.log(team.black_text);
            } else {
                $(jquerySelector + " .logo img").attr('src', `../team_logos/DEFAULT.png`);
                $(jquerySelector + " .team-color").attr('fill', '#324044');
                $(jquerySelector).css('color', 'white');
            }
            if (!winner && played) {
                $(jquerySelector + " .team-color").attr('fill', '#1d1d1d');
                $(jquerySelector).css('color', 'white');
            }
        }
    </script>
    <script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>